package golang

import (
	_ "embed"

	"github.com/fatih/color"

	"git.icechen.cn/pkg/wujian_develop_tool/util"
)

//go:embed "Dockerfile.tpl"
var dockerfileTemplate string

//go:embed "main.tpl"
var mainGoTemplate string

func GenDockerfile(name string) error {
	color.Green("正在生成dockerfile...")
	err := util.TemplateToFile("app/api/"+name+"/Dockerfile", dockerfileTemplate, map[string]string{"Name": name})
	if err != nil {
		return err
	}
	return util.TemplateToFile("app/api/"+name+"/main.go", mainGoTemplate, nil)
}
